Rikka with Subset HDU

来源:互联网 发布:javaweb考试系统源码 编辑:程序博客网 时间:2024/05/21 07:47

As we know, Rikka is poor at math. Yuta is worrying about this situation, so he gives Rikka some

math tasks to practice. There is one of them:

Yuta has nn positive A1−An and their sum is m. Then for each subset S of A, Yuta

calculates the sum of S.

Now, Yuta has got 2n numbers between [0,m] For each i∈[0,m] he counts the number of

i s he got as Bi.

Yuta shows Rikka the array Bi and he wants Rikka to restore A1−An

It is too difficult for Rikka. Can you help her?

Input

The first line contains a number t(1≤t≤70), the number of the testcases.

For each testcase, the first line contains two numbers n,m(1≤n≤50,1≤m≤10e4)

The second line contains m+1 numbers B0−Bm(0≤Bi≤2n)

Output

For each testcase, print a single line with n numbers A1−An.

It is guaranteed that there exists at least one solution. And if there are different solutions, print the

lexicographic minimum one.

Sample Input

2
2 3
1 1 1 1
3 3
1 3 3 1

Sample Output

1 2
1 1 1

Hint

In the first sample, A is [1,2]. A has four subsets [],[1],[2],[1,2] and the sums of each subset

are 0,1,2,3. So B=[1,1,1,1]


题目大意:有两个数组 A[] 和 B[] ,给出两个数 n,m,A[] 数组中有 n  个数,所有的数之和为 m 。接下来一行输入B数组,B[x] 数组中装的是 A[] 中和为 x 的自己的个数.  样例:A[] 数组为 [1,2], 那么它的子集为 [] ,[1], [2], [1,2].这些子集的和为 0,1,2,3。 所以 B[0]=1 ,  B[1]=1, B[2]=1, B[3]=1;现在给出 B 数组,求 A 数组。

   第二个样例的意思是: 0 1 2 3 的子集个数分别有1 3 3 1个,原集合a一共有3个元素


题目分析:  

                       cnt[i]表示子集的和为 i 的子集个数

               sum[i]表示求到当前位置之前子集和为i的子集个数.

      首先我们发现原集合中0的个数是好求的,      2^num[0]=cnt[0]

          

num[i]*sum[0]+sum[i]=cnt[i],也就是说一共和为 i 的子集个数等于集合中数字 i 的个数乘和为0的子集个数再加上之前那些由>0&&<i的元素构成的子集中和为i的个数
然后我们每次求出一个num[i]后,用完全背包的思想将这num[i]个i一个一个的加入到集合中,用完全背包的思想更新sum数组就行了。

代码如下:
#include <bits/stdc++.h>using namespace std;const int maxn = 5e5+500;int n,m;long long cnt[maxn];long long sum[maxn];int num[maxn];///A集合中值为 i 的数量int main(){    int t;    scanf("%d",&t);    while (t--)    {        memset(sum,0,sizeof(sum));        memset(num,0,sizeof(num));        scanf("%d%d",&n,&m);        for (int i=0; i<=m; ++i)            scanf("%lld",&cnt[i]);        num[0]=0;        sum[0]=cnt[0];        while((1<<num[0])<cnt[0])///2^num[0]<cnt[0]            num[0]++;        for(int i=1; i<=m; ++i)        {            num[i]=(cnt[i]-sum[i])/sum[0];///num[i]*sum[0]+sum[i]=cnt[i]            for (int j=1; j<=num[i];++j) ///一个一个的加入几个            {                for (int k=m; k>=i;--k) ///完全背包思想更新sum                {                    sum[k]+=sum[k-i];                }            }        }        vector<int> vec;        for (int i=0;i<=m;++i)        {            for (int j=0; j<num[i]; ++j)                vec.push_back(i);        }        for (int i=0; i<vec.size(); ++i)            printf("%d%c",vec[i],i==(vec.size()-1)?'\n':' ');    }    return 0;}


原创粉丝点击